- README

- Top Level Namespace
- Adler32
- ArgumentError
- Array
- Atomic
- Base64
  - Error
- Benchmark
  - BM
    - Job
    - Tms
  - IPS
    - Entry
    - Job
- BigFloat
- BigInt
- BigRational
- BitArray
- Bool
- Box
- Bytes
- Channel
  - Buffered
  - ClosedError
  - ReceiveAction
  - SelectAction
  - SendAction
  - Unbuffered
- Char
  - Reader
- Class
- Colorize
  - Object
  - ObjectExtensions
- Comparable
- Complex
- Concurrent
  - CanceledError
- CRC32
- Crypto
  - Bcrypt
    - Error
    - Password
  - Blowfish
  - Subtle
- CSV
  - Builder
    - Row
  - Error
  - Lexer
  - MalformedCSVError
  - Parser
  - Row
  - Token
    - Kind
- Debug
  - DWARF
    - Abbrev
      - Attribute
    - AT
    - FORM
    - Info
      - Value
    - LineNumbers
      - Register
      - Row
      - Sequence
    - LNE
    - LNS
    - Strings
    - TAG
  - ELF
    - Endianness
    - Error
    - Ident
    - Klass
    - Machine
    - OSABI
    - SectionHeader
      - Flags
      - Type
    - Type
- Deque
- Digest
  - Base
  - MD5
  - SHA1
- Dir
- DivisionByZero
- DL
- ECR
- Enum
- Enumerable
  - EmptyError
- ENV
- Errno
- Exception
- Fiber
- File
  - Stat
- FileUtils
- Flate
  - Error
  - Reader
  - Strategy
  - Writer
- Float
  - Primitive
- Float32
- Float64
- GC
  - Stats
- Gzip
  - Error
  - Header
  - Reader
  - Writer
- Hash
- HTML
- HTTP
  - Client
    - BodyType
    - Response
  - CompressHandler
  - ComputedContentTypeHeader
  - Cookie
  - Cookies
  - ErrorHandler
  - FormData
    - Builder
    - Error
    - FileMetadata
    - Parser
    - Part
  - Handler
    - Proc
  - Headers
  - LogHandler
  - Multipart
    - Builder
    - Error
    - Parser
  - Params
    - Builder
  - Request
  - Server
    - Context
    - RequestProcessor
    - Response
  - StaticFileHandler
    - DirectoryListing
  - WebSocket
  - WebSocketHandler
- Indexable
- IndexError
- INI
- Int
  - Primitive
  - Signed
  - Unsigned
- Int16
- Int32
- Int64
- Int8
- InvalidByteSequenceError
- IO
  - Buffered
  - ByteFormat
    - BigEndian
    - LittleEndian
    - NetworkEndian
    - SystemEndian
  - Delimited
  - EncodingOptions
  - EOFError
  - Error
  - FileDescriptor
  - Hexdump
  - Memory
  - MultiWriter
  - Seek
  - Sized
  - Timeout
- IPSocket
- Iterable
- Iterator
  - IteratorWrapper
  - Stop
- JSON
  - Any
  - Builder
    - ArrayState
    - DocumentEndState
    - DocumentStartState
    - ObjectState
    - StartState
    - State
  - Error
  - Lexer
  - ParseException
  - Parser
  - PullParser
  - Token
  - Type
- KeyError
- Levenshtein
  - Finder
- LLVM
  - ABI
    - AArch64
    - ArgKind
    - ArgType
    - ARM
    - FunctionType
    - X86
    - X86_64
      - RegClass
  - AtomicOrdering
  - AtomicRMWBinOp
  - Attribute
  - AttributeIndex
  - BasicBlock
  - BasicBlockCollection
  - Builder
  - CallConvention
  - CodeGenFileType
  - CodeGenOptLevel
  - CodeModel
  - Context
  - DIBuilder
  - DIFlags
  - DwarfTag
  - DwarfTypeEncoding
  - Function
  - FunctionCollection
  - FunctionPassManager
    - Runner
  - GenericValue
  - GlobalCollection
  - InstructionCollection
  - IntPredicate
  - JITCompiler
  - Linkage
  - MemoryBuffer
  - Module
  - ModuleFlag
  - ModulePassManager
  - ParameterCollection
  - PassManagerBuilder
  - PassRegistry
  - PhiTable
  - RealPredicate
  - RelocMode
  - Target
  - TargetData
  - TargetMachine
  - Type
    - Kind
  - Value
    - Kind
  - ValueMethods
  - VerifierFailureAction
- Logger
  - Formatter
  - Severity
- Markdown
  - HTMLRenderer
  - Parser
    - PrefixHeader
    - UnorderedList
  - Renderer
- Math
- Mutex
- NamedTuple
- Nil
- Number
  - Primitive
- OAuth
  - AccessToken
  - Consumer
  - Error
  - RequestToken
- OAuth2
  - AccessToken
    - Bearer
    - Mac
  - Client
  - Error
  - Session
- Object
- OpenSSL
  - Digest
    - Error
    - UnsupportedError
  - DigestBase
  - Error
  - HMAC
  - MD5
  - SHA1
  - SSL
    - Context
      - Client
      - Server
    - Error
    - ErrorType
    - Modes
    - Options
    - Socket
      - Client
      - Server
    - VerifyMode
    - X509VerifyFlags
- OptionParser
  - Exception
  - InvalidOption
  - MissingOption
- PartialComparable
- Pointer
  - Appender
- PrettyPrint
- Proc
- Process
  - Env
  - Status
  - Stdio
  - Tms
- Random
  - MT19937
- Range
- Readline
  - CompletionProc
  - KeyBindingProc
- Reference
- Reflect
- Regex
  - MatchData
  - Options
- SecureRandom
- Set
- Signal
- Slice
- Socket
  - Address
  - Addrinfo
  - Error
  - Family
  - IPAddress
  - Protocol
  - Server
  - Type
  - UNIXAddress
- Spec
  - Expectations
  - Methods
  - ObjectExtensions
- StaticArray
- String
  - Builder
  - RawConverter
- StringPool
- StringScanner
- Struct
- Symbol
- System
- TCPServer
- TCPSocket
- Tempfile
- Termios
  - AttributeSelection
  - BaudRate
  - ControlMode
  - InputMode
  - LineControl
  - LocalMode
  - OutputMode
- Time
  - DayOfWeek
  - EpochConverter
  - EpochMillisConverter
  - Format
    - Error
  - Kind
  - MonthSpan
  - Span
- Tuple
- TypeCastError
- UDPSocket
- UInt16
- UInt32
- UInt64
- UInt8
- Unicode
  - CaseOptions
- Union
- UNIXServer
- UNIXSocket
- URI
  - Error
- Value
- WeakRef
- XML
  - Attributes
  - AttributeType
  - Builder
  - Error
  - HTMLParserOptions
  - Namespace
  - Node
  - NodeSet
  - ParserOptions
  - Reader
  - SaveOptions
  - Type
  - XPathContext
- YAML
  - Any
  - Builder
  - Error
  - EventKind
  - ParseException
  - Parser
  - PullParser
  - Type
- Zip
  - CompressionMethod
  - Error
  - File
    - Entry
  - FileInfo
  - Reader
    - Entry
  - Writer
    - Entry
- Zlib
  - Error
  - Reader
  - Writer

# struct HTTP::Params

- HTTP::Params
- Struct
- Value
- Object

## Overview

Represents a collection of http parameters and their respective values.

## Included Modules

- Enumerable({String, String})

## Defined in:

## Class Method Summary

- .build(&block : Builder -> ) : String

  Builds an url-encoded HTTP form/query.

- .encode(hash : Hash(String, _))

  Returns the given key value pairs as a url-encoded HTTP form/query.

- .encode(named_tuple : NamedTuple)

  Returns the given key value pairs as a url-encoded HTTP form/query.

- .new(raw_params : Hash(String, Array(String)))
- .parse(query : String) : self

  Parses an HTTP query string into a `HTTP::Params`

- .parse(query : String, &block)

  Parses an HTTP query and yields each key-value pair.

## Instance Method Summary

- #==(other : self)
- #==(other)
- #[](name)

  Returns first value for specified param name.

- #[]=(name, value)

  Sets first value for specified param name.

- #[]?(name)

  Returns first value or `nil` for specified param name.

- #add(name, value)

  Appends new value for specified param name.

- #delete(name)

  Deletes first value for provided param name.

- #delete_all(name)

  Deletes all values for provided param name.

- #each(&block)

  Allows to iterate over all name-value pairs.

- #fetch(name, &block)

  Returns first value for specified param name.

- #fetch(name)

  Returns first value for specified param name.

- #fetch(name, default)

  Returns first value for specified param name.

- #fetch_all(name)

  Returns all values for specified param name.

- #has_key?(*args, **options, &block)

  Returns `true` if param with provided name exists.

- #has_key?(*args, **options)

  Returns `true` if param with provided name exists.

- #set_all(name, values)

  Sets all values for specified param name at once.

- #to_s(io)

  Serializes to string representation as http url-encoded form.

### Instance methods inherited from module `Enumerable({String, String})`

all?(&block)
all? all?, any?(&block)
any? any?, chunks(&block : {String, String} -> U) forall U chunks, compact_map(&block) compact_map, count(&block)
count(item) count, cycle(n, &block)
cycle(&block) cycle, each(&block : {String, String} -> _) each, each_cons(count : Int, reuse = false, &block) each_cons, each_slice(count : Int, reuse = false, &block) each_slice, each_with_index(offset = 0, &block) each_with_index, each_with_object(obj, &block) each_with_object, find(if_none = nil, &block) find, first(count : Int)
first first, first? first?, flat_map(&block : {String, String} -> Array(U) | Iterator(U) | U) forall U flat_map, grep(pattern) grep, group_by(&block : {String, String} -> U) forall U group_by, in_groups_of(size : Int, filled_up_with : U = nil) forall U
in_groups_of(size : Int, filled_up_with : U = nil, reuse = false, &block) forall U in_groups_of, includes?(obj) includes?, index(&block)
index(obj) index, index_by(&block : {String, String} -> U) forall U index_by, join(separator, io)
join(separator = "")
join(separator, io, &block)
join(separator = "", &block) join, map(&block : {String, String} -> U) forall U map, map_with_index(&block : {String, String}, Int32 -> U) forall U map_with_index, max max, max? max?, max_by(&block : {String, String} -> U) forall U max_by, max_by?(&block : {String, String} -> U) forall U max_by?, max_of(&block : {String, String} -> U) forall U max_of, max_of?(&block : {String, String} -> U) forall U max_of?, min min, min? min?, min_by(&block : {String, String} -> U) forall U min_by, min_by?(&block : {String, String} -> U) forall U min_by?, min_of(&block : {String, String} -> U) forall U min_of, min_of?(&block : {String, String} -> U) forall U min_of?, minmax minmax, minmax? minmax?, minmax_by(&block : {String, String} -> U) forall U minmax_by, minmax_by?(&block : {String, String} -> U) forall U minmax_by?, minmax_of(&block : {String, String} -> U) forall U minmax_of, minmax_of?(&block : {String, String} -> U) forall U minmax_of?, none?(&block)
none? none?, one?(&block) one?, partition(&block) partition, product(&block)
product(initial : Number, &block)
product
product(initial : Number) product, reduce(&block)
reduce(memo, &block) reduce, reject(&block : {String, String} -> ) reject, select(&block : {String, String} -> ) select, size size, skip(count : Int) skip, skip_while(&block) skip_while, sum(initial)
sum
sum(initial, &block)
sum(&block) sum, take_while(&block) take_while, to_a to_a, to_h to_h, to_set to_set

### Instance methods inherited from struct `Struct`

==(other : self) : Bool ==, hash : Int32 hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io) to_s

### Instance methods inherited from struct `Value`

==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash hash, inspect(io : IO)
inspect inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s
to_s(io : IO) to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try

### Class methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io) : self from_yaml

## Class Method Detail

def self.build(&block : Builder -> ) : String #

Builds an url-encoded HTTP form/query.

The yielded object has an `#add` method that accepts two arguments, a key (`String`) and a value (`String` or `Nil`). Keys and values are escaped using `URI#escape`.

    params = HTTP::Params.build do |form|
      form.add "color", "black"
      form.add "name", "crystal"
      form.add "year", "2012 - today"
    end
    params # => "color=black&name=crystal&year=2012+-+today"

def self.encode(hash : Hash(String, _)) #

Returns the given key value pairs as a url-encoded HTTP form/query.

def self.encode(named_tuple : NamedTuple) #

Returns the given key value pairs as a url-encoded HTTP form/query.

def self.new(raw_params : Hash(String, Array(String))) #
def self.parse(query : String) : self #

Parses an HTTP query string into a `HTTP::Params`

    HTTP::Params.parse("foo=bar&foo=baz&qux=zoo")
    # => #<HTTP::Params @raw_params = {"foo" => ["bar", "baz"], "qux" => ["zoo"]}>

def self.parse(query : String, &block) #

Parses an HTTP query and yields each key-value pair.

    query = "foo=bar&foo=baz&qux=zoo"
    HTTP::Params.parse(query) do |key, value|
      # ...
    end

## Instance Method Detail

def ==(other : self) #
def ==(other) #
def [](name) #

Returns first value for specified param name.

    params = HTTP::Params.parse("email=john@example.org")
    params["email"]              # => "john@example.org"
    params["non_existent_param"] # KeyError

def []=(name, value) #

Sets first value for specified param name.

    params["item"] = "pencil"

def []?(name) #

Returns first value or `nil` for specified param name.

    params["email"]?              # => "john@example.org"
    params["non_existent_param"]? # nil

def add(name, value) #

Appends new value for specified param name. Creates param when there was no such param.

    params.add("item", "keychain")
    params.fetch_all("item") # => ["pencil", "book", "workbook", "keychain"]

def delete(name) #

Deletes first value for provided param name. If there are no values left, deletes param itself. Returns deleted value.

    params.delete("item")    # => "keychain"
    params.fetch_all("item") # => ["keynote"]

    params.delete("item") # => "keynote"
    params["item"]        # KeyError

    params.delete("non_existent_param") # KeyError

def delete_all(name) #

Deletes all values for provided param name. Returns array of deleted values.

    params.set_all("comments", ["hello, world!", ":+1:"])
    params.delete_all("comments") # => ["hello, world!", ":+1:"]
    params.has_key?("comments")   # => false

def each(&block) #

Allows to iterate over all name-value pairs.

    params.each do |name, value|
      puts "#{name} => #{value}"
    end

    # Outputs:
    # email => john@example.org
    # item => keychain
    # item => keynote

def fetch(name, &block) #

Returns first value for specified param name. Fallbacks to return value of provided block when there is no such param.

    params.fetch("email") { raise "Email is missing" }              # raises "Email is missing"
    params.fetch("non_existent_param") { "default computed value" } # => "default computed value"

def fetch(name) #

Returns first value for specified param name.

    params.fetch("email")              # => "john@example.org"
    params.fetch("non_existent_param") # KeyError

def fetch(name, default) #

Returns first value for specified param name. Fallbacks to provided default value when there is no such param.

    params.fetch("email", "none@example.org")           # => "john@example.org"
    params.fetch("non_existent_param", "default value") # => "default value"

def fetch_all(name) #

Returns all values for specified param name.

    params.set_all("item", ["pencil", "book", "workbook"])
    params.fetch_all("item") # => ["pencil", "book", "workbook"]

def has_key?(*args, **options, &block) #

Returns `true` if param with provided name exists.

    params.has_key?("email")   # => true
    params.has_key?("garbage") # => false

def has_key?(*args, **options) #

Returns `true` if param with provided name exists.

    params.has_key?("email")   # => true
    params.has_key?("garbage") # => false

def set_all(name, values) #

Sets all values for specified param name at once.

    params.set_all("item", ["keychain", "keynote"])
    params.fetch_all("item") # => ["keychain", "keynote"]

def to_s(io) #

Serializes to string representation as http url-encoded form.

    params = HTTP::Params.parse("item=keychain&item=keynote&email=john@example.org")
    params.to_s # => "item=keychain&item=keynote&email=john%40example.org"

TODO `#to_s` should escape @ to %40 ?